﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls;
using Telerik.Windows;
using System.Collections;
using Telerik.Windows.Controls.GridView;
using System.ComponentModel;

namespace _300503_GridViewToTreeViewDnD
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			this.myGridView.ItemsSource = GenerateProducts();
		}
		#region Data Collections

		public class ProductViewModel : INotifyPropertyChanged
		{
			public ProductViewModel()
			{
				userSelectionChanged = false;
			}
			public string Name { get; set; }
			public string Description { get; set; }
			public decimal UnitPrice { get; set; }
			public bool userSelectionChanged { get; set; }

			private Color colorBrush;
			/// <summary>
			///     Gets or sets the name.
			/// </summary>
			public Color ColorBrush
			{
				get
				{
					return this.colorBrush;
				}
				set
				{
					if (this.colorBrush != value)
					{
						this.colorBrush = value;
						OnPropertyChanged("ColorBrush");
					}
				}
			}


			/// <summary>
			///     Event for INotifyPropertyChanged.
			/// </summary>
			public event PropertyChangedEventHandler PropertyChanged;

			/// <summary>
			///     Raises the INotifyPropertyChanged event.
			/// </summary>
			/// <param name="propertyName">The property to be included in the INotifyPropertyChanged EventArgs.</param>
			protected virtual void OnPropertyChanged(String propertyName)
			{
				if (PropertyChanged != null)
				{
					PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
				}
			}

		}

		private ObservableCollection<ProductViewModel> GenerateProducts()
		{
			ObservableCollection<ProductViewModel> result = new ObservableCollection<ProductViewModel>();
			for (int i = 1; i < 20; i++)
			{
				ProductViewModel product = new ProductViewModel()
				{
					Name = String.Format("Name {0}", i),
					Description = String.Format("Description {0}", i),
					UnitPrice = i * 100,
					ColorBrush = Colors.White
				};
				result.Add(product);
			}
			return result;
		}

		#endregion

		private void RadColorPicker_SelectedColorChanged(object sender, EventArgs e)
		{
			RadColorSelector colorPicker = sender as RadColorSelector;
			RadDropDownButton button = colorPicker.ParentOfType<RadDropDownButton>();
			if ( (colorPicker.DataContext as ProductViewModel).userSelectionChanged)
			{
				if (button != null && button.IsOpen == true)
				{
					button.IsOpen = false;
				}
			}
			(colorPicker.DataContext as ProductViewModel).userSelectionChanged = true;
		}

	}
}
